package RPM::Source::TransformContainer;

use strict;
use warnings;

our $VERSION=0.003;

use RPM::Source::Shared::ResourceContainer;

our @SUPPORT_CLASSES;
our @RESOURCE_CLASSES;
our @FACTORY_CLASSES;
our $PLAYER;
our $WRITER;
our $INPUT_HANDLER;
our $ParentProvider;
our $RPMEditorProvider;
# TODO: move GET_SPEC_PARENT here from BundleImport.pm
# our $GET_SPEC_PARENT

# those are initialized during use in RPM::Source::Transformation::*
BEGIN {
 @SUPPORT_CLASSES=qw//;
 @RESOURCE_CLASSES=qw//;
 @FACTORY_CLASSES=qw//;
 $PLAYER=undef;
 $WRITER=undef;
 $INPUT_HANDLER=undef;
 $ParentProvider=undef;
 $RPMEditorProvider=undef;
}

sub debug_container {
    print STDERR "DEBUG:RPM::Source::TransformContainer:","\n";
    print STDERR "DEBUG:SUPPORT_CLASSES:\n\t",join("\n\t", @SUPPORT_CLASSES),"\n";
    print STDERR "DEBUG:RESOURCE_CLASSES:\n\t",join("\n\t", @RESOURCE_CLASSES),"\n";
    print STDERR "DEBUG:FACTORY_CLASSES:\n\t",join("\n\t", @FACTORY_CLASSES),"\n";
    print STDERR "DEBUG:PLAYER=",&__U($PLAYER),"\n";
    print STDERR "DEBUG:WRITER=",&__U($WRITER),"\n";
    print STDERR "DEBUG:INPUT_HANDLER=",&__U($INPUT_HANDLER),"\n";
    print STDERR "DEBUG:ParentProvider=",&__U($ParentProvider),"\n";
    print STDERR "DEBUG:RPMEditorProvider=",&__U($RPMEditorProvider),"\n";
}

sub __U {
    return defined($_[0]) ? $_[0]: '(undef)';
}

sub get_longopt {
    my ($self)=@_;
#    print STDERR "DEBUG:SUPPORT_CLASSES:\n\t",join("\n\t", @RPM::Source::TransformContainer::SUPPORT_CLASSES),"\n";
#    print STDERR "DEBUG:ParentProvider=$RPM::Source::TransformContainer::ParentProvider\n";
    return map {$_->get_longopt} 'RPM::Source::Shared::ResourceContainer', @SUPPORT_CLASSES, @RESOURCE_CLASSES, @FACTORY_CLASSES;
}

sub longopt_usage {
    map {$_->longopt_usage} 'RPM::Source::Shared::ResourceContainer', @SUPPORT_CLASSES, @RESOURCE_CLASSES, @FACTORY_CLASSES;
}

sub before_process_options {
    my ($self)=@_;
    map {$_->before_process_options} 'RPM::Source::Shared::ResourceContainer', @SUPPORT_CLASSES, @RESOURCE_CLASSES, @FACTORY_CLASSES;
}

sub process_options {
    my ($self)=@_;
    map {$_->process_options} 'RPM::Source::Shared::ResourceContainer', @SUPPORT_CLASSES, @RESOURCE_CLASSES, @FACTORY_CLASSES;
}

1;
