package RPM::Source::Transformation::Resource::Buildreq;

use strict;
use warnings;
use Carp;
use Data::Dumper;

use RPM::Source::Tools::BuildReqStorage;
use RPM::Source::Tools::HackOverSourceAnalyzer;
use RPM::Source::Transformation::Resource;
our @ISA=qw/RPM::Source::Transformation::Resource/;

our $verbose=0;

push @RPM::Source::TransformContainer::RESOURCE_CLASSES, __PACKAGE__;

sub prepare_resource {
    my (undef,$spec,$parent,$opt,$resourceobj)=@_;
    if ($resourceobj->{'__buildreq'}) {
	print STDERR "Oops! internal error: buildreq resource still exist: destroyed\n";
	print STDERR Data::Dumper::Dumper($resourceobj->{'__buildreq'}),"\n";
	$resourceobj->{'__buildreq'}=undef;
    } else {
	print STDERR "buildreq: resourceobj ".ref($resourceobj)." has no __buildreq\n" if $verbose>1;
    }
}

package RPM::Source::Shared::ResourceContainer;

sub buildreq {
    my ($self)=@_;
    my $buildreq=$self->{'__buildreq'};
    return $buildreq if $buildreq;
    $self->{'__buildreq'}=RPM::Source::Tools::BuildReqStorage->new(
	&RPM::Source::Tools::HackOverSourceAnalyzer::get_ignore_buildreq_hack_opts(),
	);
    print STDERR "buildreq: created buildreq\n" if $verbose;
    return $self->{'__buildreq'};
}

1;
